<?php

require_once( dirname(__FILE__).'/base/basepermissionquarkpool.php' );

/**
 * Autogenerated class PermissionQuarkPool_Model
 *
 * @todo: documentation
 */
class PermissionQuarkPool_Model extends BasePermissionQuarkPool_Model {
	/**
	 * Build a permission quark (int) from a table and a key.
	 *
	 * For each unique pair (table, key), a unique id is returned, such as
	 * Quark(table1,key1) == Quark(table2,key2) iff table1 == table2 and
	 * key1 == key2
	 *
	 * @param $table string
	 * @param $key string
	 * @return integer
	 */
	public static function build($table, $key) {
		$quark = static::all()
			->reduce_by('foreign_table', $table, '=')
			->reduce_by('foreign_key', $key, '=')
			->one();

		if(!$quark) {
			$quark = new PermissionQuark_Model();
			$quark->set_foreign_table($table);
			$quark->set_foreign_key($key);
			$quark->save();
		}

		return $quark->get_id();
	}
}
